"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAccount = exports.getCreateAccountInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getCreateAccountInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u32()],
        ['lamports', (0, umi_1.mapAmountSerializer)(s.u64(), 'SOL', 9)],
        ['space', s.u64()],
        ['programId', s.publicKey()],
    ], { description: 'CreateAccountInstructionData' }), (value) => ({ ...value, discriminator: 0 }));
}
exports.getCreateAccountInstructionDataSerializer = getCreateAccountInstructionDataSerializer;
// Instruction.
function createAccount(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
    // Resolved accounts.
    const payerAccount = input.payer ?? context.payer;
    const newAccountAccount = input.newAccount;
    // Payer.
    signers.push(payerAccount);
    keys.push({
        pubkey: payerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(payerAccount, true),
    });
    // New Account.
    signers.push(newAccountAccount);
    keys.push({
        pubkey: newAccountAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newAccountAccount, true),
    });
    // Data.
    const data = getCreateAccountInstructionDataSerializer(context).serialize(input);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = Number(input.space) + umi_1.ACCOUNT_HEADER_SIZE;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.createAccount = createAccount;
//# sourceMappingURL=createAccount.js.map