"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.recoverNestedAssociatedToken = void 0;
const umi_1 = require("@metaplex-foundation/umi");
// Instruction.
function recoverNestedAssociatedToken(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL');
    // Resolved accounts.
    const nestedAssociatedAccountAddressAccount = input.nestedAssociatedAccountAddress;
    const nestedTokenMintAddressAccount = input.nestedTokenMintAddress;
    const destinationAssociatedAccountAddressAccount = input.destinationAssociatedAccountAddress;
    const ownerAssociatedAccountAddressAccount = input.ownerAssociatedAccountAddress;
    const ownerTokenMintAddressAccount = input.ownerTokenMintAddress;
    const walletAddressAccount = input.walletAddress;
    const tokenProgramAccount = input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    };
    // Nested Associated Account Address.
    keys.push({
        pubkey: nestedAssociatedAccountAddressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(nestedAssociatedAccountAddressAccount, true),
    });
    // Nested Token Mint Address.
    keys.push({
        pubkey: nestedTokenMintAddressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(nestedTokenMintAddressAccount, false),
    });
    // Destination Associated Account Address.
    keys.push({
        pubkey: destinationAssociatedAccountAddressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(destinationAssociatedAccountAddressAccount, true),
    });
    // Owner Associated Account Address.
    keys.push({
        pubkey: ownerAssociatedAccountAddressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(ownerAssociatedAccountAddressAccount, false),
    });
    // Owner Token Mint Address.
    keys.push({
        pubkey: ownerTokenMintAddressAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(ownerTokenMintAddressAccount, false),
    });
    // Wallet Address.
    signers.push(walletAddressAccount);
    keys.push({
        pubkey: walletAddressAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(walletAddressAccount, true),
    });
    // Token Program.
    keys.push({
        pubkey: tokenProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenProgramAccount, false),
    });
    // Data.
    const data = new Uint8Array();
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.recoverNestedAssociatedToken = recoverNestedAssociatedToken;
//# sourceMappingURL=recoverNestedAssociatedToken.js.map