"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferTokens = exports.getTransferTokensInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getTransferTokensInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['amount', s.u64()],
    ], { description: 'TransferTokensInstructionData' }), (value) => ({ ...value, discriminator: 3 }));
}
exports.getTransferTokensInstructionDataSerializer = getTransferTokensInstructionDataSerializer;
// Instruction.
function transferTokens(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    // Resolved accounts.
    const sourceAccount = input.source;
    const destinationAccount = input.destination;
    const authorityAccount = input.authority ?? context.identity;
    // Source.
    keys.push({
        pubkey: sourceAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(sourceAccount, true),
    });
    // Destination.
    keys.push({
        pubkey: destinationAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(destinationAccount, true),
    });
    // Authority.
    signers.push(authorityAccount);
    keys.push({
        pubkey: authorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(authorityAccount, false),
    });
    // Data.
    const data = getTransferTokensInstructionDataSerializer(context).serialize(input);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.transferTokens = transferTokens;
//# sourceMappingURL=transferTokens.js.map